var toPreload = new Set();
var preloadIter;
var preload = {
	paths: new Set(),
	files: new Set(),
	temp:{

	},
	perm:{

	},
	canvas:{

	}
}

//make scene uninteractable until load

function initPreload(){
	preload.permElem = document.getElementById("preload-perm-elem");
	preload.tempElem = document.getElementById("preload-temp-elem");
}

function preloadSceneResources(script){
	for(let command of script){
		let fn;
		let src;
		switch(command.substr(1, command.lastIndexOf(">") -1)){
			case "EV":
			case "BG":
				fn = command.substr(command.lastIndexOf(">") +1, command.indexOf(",") - (command.lastIndexOf(">") +1)).trim();
				if(fn == "black" || fn == "white"){
					continue;
				}
				src = createImagePath(fn);
			break;
			case "ACTOR":
				fn = command.substr(command.indexOf(",") + 1, command.substr(command.indexOf(",") + 1).indexOf(",")).trim();
				src = createImagePath(fn);
			break;
			case "VOICE_PLAY":
				src = constructVoiceAudioPath(command.substr(command.lastIndexOf(">") +1).trim(), scene.id);
			break;
			case "BGM_PLAY":
				src = constructBGMAudioPath(command.substr(command.lastIndexOf(">") +1, command.indexOf(",") - (command.lastIndexOf(">") +1)).trim());
			break;
			case "SE_PLAY":
				src = constructSEAudioPath(command.substr(command.lastIndexOf(">") +1).trim());
			break;
			default:
			break;
		}
		preload.paths.add(src);
	}
	preload.paths.delete(undefined);
	preload.iter = preload.paths.values();
	loadSceneResources();
}

function preloadTABAResources(){
	for(let part in sceneData[scene.id].SCRIPTS){
		let curPart = sceneData[scene.id].SCRIPTS[part];
		let folder = curPart.FOLDER;
		let script;
		if(scene.translated){
			for(let tl of curPart.TRANSLATIONS){
				if(tl.LANGUAGE == scene.language && tl.TRANSLATOR == scene.translator){
					script = tl.SCRIPT;
					break;
				}
			}
		} else {
			script = curPart.SCRIPT
		}
		let path = "./TABAScenes/" + folder;
		for(let cmd of script){
			let src = cmd.src;
            let type = cmd.type;
            let id = cmd.id;
            let fullPath;

            switch(type){
            	case "BG":
            	case "EV":
            	case "OV":
            		if(src){
            			fullPath = path + "/images/" + src.split("/")[src.split("/").length -1];
            		}
            	break;
            	case "TXT":
	            	if(src){
            			fullPath = path + "/sounds/" + src.split("/")[src.split("/").length -1];
            		}
            	break;
            	default:
            	break;
            }
            if(fullPath != undefined && !fullPath.includes("non_resource")){
            	preload.files.add(fullPath.split("/")[fullPath.split("/").length-1]);
            	preload.paths.add(fullPath);
            }
		}
		preload.paths.delete(undefined);
		preload.iter = preload.paths.values();
		loadSceneResources();
	}
}

function loadSceneResources(){
	let path = preload.iter.next().value;
	if(path == null || path == undefined){
		if(scene.type == H_TABA){
			// Multi-part scenes may use the same files so using paths
			// doesn't always work.
			if(preload.files.size == Object.keys(preload.temp).length ){
				preload.paths = new Set();
				preload.files = new Set();
				startScene();
				return;
			}
		} else {
			// I don't know why filenames doesn't work and paths does
			// for RPGX but I also don't care enough to find out.
			if(preload.paths.size == Object.keys(preload.temp).length ){
				preload.paths = new Set();
				preload.files = new Set();
				startScene();
				return;
			}
		}
		console.log("Error code: Some shit's not fucking loading")
		return;
	}
	let fn = path.substr(path.lastIndexOf("/") + 1, path.lastIndexOf(".") - path.lastIndexOf("/") - 1);
	if(preload.temp[fn]){
		loadSceneResources();
		return;
	}
	let ext = path.substr(path.lastIndexOf(".")  + 1);
	if(ext == "png" || ext == "jpg"){
		let img = new Image();
		img.className = "tempPreloadImage";
		img.onload = function(){
			preload.temp[fn] = img;
			preload.tempElem.append(img);
			loadSceneResources();
		}
		img.src = path;

	} else if(ext == "ogg"){
		let audio = new Audio();
		audio.oncanplay = function(){
			preload.temp[fn] = audio;
			loadSceneResources();
		}
		audio.src = path;
	}
}

function createCanvases(script, pairList=null){
	let evData = getCommandData(script, "<EV>", 0);
	evData = [...new Set(evData)];
	let prevParent;
	for(let ev of evData){
		if(!preload.canvas.hasOwnProperty(ev) && pairList != null){
			let foundMatch = false;
			for(let pair of pairList){
				prevParent = pair.parent;
				if(ev == pair.parent){
					foundMatch = true;
					createCanvas([pair.parent]);
					break;
				} else if(ev == pair.child){
					foundMatch = true;
					createCanvas([pair.parent, pair.child]);
					break;	
				}
			}
			if(!foundMatch){
				// Sometimes EVs aren't listed in the pair list.
				if(prevParent == null){
					createCanvas([ev])
				} else {
					createCanvas([prevParent, ev]);
				}
			}
		} else {
			createCanvas([ev]);
		}
	}
	// for(let img of sceneData[id].hierarchy.pairList){
	// 	if(!preload.canvas.hasOwnProperty(img.parent)){
	// 		createCanvas([img.parent]);
	// 	}
	// 	if(!preload.canvas.hasOwnProperty(img.child)){
	// 		createCanvas([img.parent, img.child]);
	// 	}
	// }
}

function createCGCanvases(ev, pairList=null){
	console.log(ev + ", " + pairList)
	let prevParent;
	if(!preload.canvas.hasOwnProperty(ev) && pairList != null){
		let foundMatch = false;
		for(let pair of pairList){
			prevParent = pair.parent;
			if(ev == pair.parent){
				foundMatch = true;
				createCanvas([pair.parent]);
				break;
			} else if(ev == pair.child){
				foundMatch = true;
				createCanvas([pair.parent, pair.child]);
				break;	
			}
		}
		if(!foundMatch){
			// Sometimes EVs aren't listed in the pair list.
			if(prevParent == null){
				createCanvas([ev])
			} else {
				createCanvas([prevParent, ev]);
			}
		}
	} else {
		createCanvas([ev]);
	}
}

function createCanvas(files){
	let name = files[files.length - 1];
	let canvas = document.createElement("canvas");
	canvas.id = name
	canvas.height = 720;
	canvas.width = 960;
	main.elements.canvasHoldElem.append(canvas);
	let ctx = canvas.getContext("2d");

	for(file of files){
		let image = new Image();
		image.onload = function(){
			ctx.drawImage(image, 160, 0, 960, 720, 0, 0, 960, 720);
		}
		image.src = createImagePath(file);
	}
	canvas.classList.add("tempPreloadImage");
	preload.canvas[name] = canvas;
}

function createImagePath(file){
	if(scene.type == H_RPGX || scene.type == CG_RPGX){
		let id;
		if(file.startsWith("chr_0")){
			id = file.replace("chr_", "").replace("_r18", "").replace(/[a-z]/g, "");
		} else if(file.startsWith("exev")){
			id = (file.split("_")[0] + file.split("_")[1].replace(/[a-z]/, "")).replace("ev", "");
		// } else if(file.startsWith("ex")){
		// 	id = file.split("_")[0] + file.split("_")[1].replace(/[a-z]/, "");
		// 	console.log("ex match: " + file + ", " + id + ", " + scene.id)
		} else {
			console.log("no match: " + file)
			id = scene.type == H_RPGX ? scene.id : cgViewer.scene;
		}
		return "./scenes/" + id + "/images/" + file + ".png";
	} else if(scene.type == STORY_RPGX){
		if(/[a-z]+_[a-z][0-9][0-9][0-9][a-z]/.test(file) || file.startsWith("chr_")){
			return "./Story/char/" + file + ".png";
		} else if(file.startsWith("ef") || file.startsWith("nc") || file.startsWith("chrnc")){
			return "./Story/bg/" + file + ".png";
		} else if(file.startsWith("stv")){
			return "./Story/ev/" + file + ".png";
		}
	} else if(scene.type == H_TABA){

	}
}

function getCommandData(script, tag, idx=null){
	let data = []
	for(let cmd of script){
		if(cmd.startsWith(tag)){
			if(idx != null){
				data.push(cmd.substr(cmd.lastIndexOf(">") + 1).split(",")[idx]);
			} else {
				data.push(cmd.substr(cmd.lastIndexOf(">") + 1));
			}
		}
	}
	return data
}

// var trans = new Set();
// for(let key in sceneData){
// 	console.log(getCommandData(sceneData[key].script, "<TRANSITION>", 0));
// }

function constructImagePath(src, id){
	return "./scenes/" + id + "/images/" + src + ".png";
}
function constructVoiceAudioPath(src, id){
	return "./scenes/" + id + "/voices/" + src + ".ogg";
}

function constructBGMAudioPath(src){
	return "./data/audio/bgm/" + src + ".ogg";
}

function constructSEAudioPath(src){
	return "./data/audio/se/" + src + ".ogg";
}

function emptyTempPreload(){
	// Kill children causes some weird shit in CG mode for the canvas holder
	// for(let key in preload.canvas){
	// 	let child = preload.canvas[key];
	// 	child.parentElement.removeChild(child)
	// }
	preload.canvas = {};
	preload.temp = {};
	preload.paths = new Set();
	preload.files = new Set();
	killChildren(document.getElementById("preload-temp-elem"));
	killChildren(main.elements.canvasHoldElem);
}

// var names = new Set();
// for(let key in sceneData){
// 	let curScene = sceneData[key];
// 	for(let cmd of curScene.script){
// 		if(cmd.startsWith("<NAME_PLATE>")){
// 			let name = cmd.substr(cmd.lastIndexOf(">") + 1);
// 			if(/[ａ-ｚＡ-Ｚ０-９？]/.test(name)){
// 				names.add(name.substr(0, /[ａ-ｚＡ-Ｚ０-９？]/.exec(name).index).trim());
// 			} else {
// 				names.add(name.trim());
// 			}
// 		}
// 	}
// }

function normalWidth(string){
	return string.replace(/[\uff01-\uff5e]/g, function(ch){
		return String.fromCharCode(ch.charCodeAt(0) - 0xfee0);
	});
}

function translateName(name){
	let append = "";
	if(/[ａ-ｚＡ-Ｚ０-９？]/.test(name)){
		let idx = /[ａ-ｚＡ-Ｚ０-９？]/.exec(name).index;
		append = " " + normalWidth(name.substr(idx));
		name = name.substr(0, idx);
	} else if(/[a-zA-Z0-9]/.test(name)){
		// Some names don't use full width for some reason
		// Seperated because I expect it to fuck up some day
		let idx = /[a-zA-Z0-9]/.exec(name).index;
		append = " " + name.substr(idx);
		name = name.substr(0, idx);
	}
	if(translatedNames.get(name)){
		return translatedNames.get(name) + append;
	} else {
		return name + append;
	}
}

function permPreload(path){
	let img = new Image();
	img.className = "permPreloadImage";
	img.onload = function(){
		preload.perm[path] = img;
		preload.permElem.append(img);
	}
	img.src = path;
}